package pl.net.linux.krzak.kchat.applet;
/*****************************/
/* kChat v1.9		     */
/* krzak@linux.net.pl        */
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.Frame;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Color;
import java.awt.List;
import java.awt.Label;
import java.awt.Button;
import java.awt.Scrollbar;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;
import java.lang.String;
import java.util.Vector;

public class kChatApplet extends Applet implements AdjustmentListener, KeyListener {
  public int sizeX = 600;
  public int sizeY = 470;
  public kChatNet net = null;
  public String login = "any";
  public String chan  = "free";
  public kChatChannel chanWnd = null;
  public kChatChannel chanWndModer = null;
  public Scrollbar sbar = null;
  public Scrollbar msbar = null;
  public TextArea input = null;
  public String msgColor = "black";
  public List nList = null;
  public boolean moderate = false;
  public Image bgImage = null;
  public Image bgImageModer = null;
  public String moderatorNick = "";
  public String selectedNick = "";
  public Frame moderFr = null;
  public Vector windowsList = new Vector();
  public String TXT[] = new String[19];
  public Label topicLabel = new Label("",Label.CENTER);
  public java.net.URL logouthtml = null;
  public kChatActions actions = null;
  // BUTTONS
  public Button bLogout = new Button();
  public Button bPrivate = new Button();
  public Button bModerator = new Button();
  public Button bClose = new Button();
  public AppletContext context = null;



public void init() {
 context  = getAppletContext();

    try {
    if ((getParameter("background") != null) && (!getParameter("background").equals("")))
	bgImage = getImage(new java.net.URL(getParameter("background")));
    if ((getParameter("backgroundmoder") != null) && (!getParameter("backgroundmoder").equals("")))
	bgImageModer = getImage(new java.net.URL(getParameter("backgroundmoder")));
    } catch (java.net.MalformedURLException e) { e.printStackTrace(); }

 setSize(sizeX, sizeY);
 setBackground(Color.white);

 chanWnd = new kChatChannel(sizeX-130,sizeY-60,this);
 chanWnd.setFont(new Font("",Font.PLAIN,12));
 chanWnd.setBackground(Color.white);
 chanWnd.setBackgroundImage(bgImage);

 sbar = new Scrollbar(Scrollbar.VERTICAL,0,1,0,100);
 sbar.addAdjustmentListener(this);
 sbar.setSize(sbar.getSize().width,sizeY-150);

 chanWnd.setScroller(sbar);

 actions = new kChatActions(this);

 nList = new List(23);
 nList.addItemListener(actions);

 bLogout.setActionCommand("LOGOUT");
 bLogout.addActionListener(actions);
 bPrivate.setActionCommand("PRIVATE");
 bPrivate.addActionListener(actions);
 bModerator.setActionCommand("MODERATOR");
 bModerator.addActionListener(actions);

 input = new TextArea("",2,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
 input.setSize(100,50);
 input.setFont(new Font("",Font.PLAIN,12));
 input.addKeyListener(this);

 Panel panel = new Panel(new BorderLayout());
 Panel leftP = new Panel(new BorderLayout());
 Panel downP = new Panel(new BorderLayout());
 Panel rightP = new Panel(new BorderLayout());
 Panel buttonsP = new Panel(new BorderLayout());

 buttonsP.add(bPrivate, BorderLayout.NORTH);
 buttonsP.add(bModerator, BorderLayout.CENTER);
 buttonsP.add(bLogout,BorderLayout.SOUTH);

 rightP.add(nList, BorderLayout.NORTH);
 rightP.add(buttonsP, BorderLayout.SOUTH);

 leftP.add(chanWnd, BorderLayout.WEST);
 leftP.add(sbar, BorderLayout.CENTER);
 leftP.add(rightP, BorderLayout.EAST);

 downP.add(input, BorderLayout.CENTER);

 panel.add(topicLabel, BorderLayout.NORTH);
 panel.add(leftP, BorderLayout.CENTER);
 panel.add(downP, BorderLayout.SOUTH);

 add(panel);


 msgColor = getParameter("color");

 logouthtml = getDocumentBase();

 // Net Thread
 net = new kChatNet(getCodeBase().getHost(),getParameter("port"),this);
 net.start();

 chan = getParameter("chan");
 // get texts
 net.send("*LANG");
 // login to system
 net.send("*LOGIN|SYSTEM|"+getParameter("login")+"|"+ getParameter("pass") +"|"+getParameter("chan")+"|"+getParameter("color")+"|");
 // get users list
 net.send("*CHECK|"+getParameter("chan")+"|");
 // get topic of channel
 net.send("*TOPIC|GET|"+getParameter("chan")+"|");
}


public void moderWinOpen(kChatApplet a) {
 Panel panel = new Panel(new BorderLayout());
 Panel pwm = new Panel(new BorderLayout());

 moderFr = new Frame(TXT[10]);
 moderFr.setSize(sizeX-108,sizeY-18+30);
 moderFr.setResizable(true);
 moderFr.setLayout(new BorderLayout());

 msbar = new Scrollbar(Scrollbar.VERTICAL,0,1,0,100);
 msbar.addAdjustmentListener(a);
 msbar.setSize(msbar.getSize().width,sizeY);

 chanWndModer = new kChatChannel(sizeX-130,sizeY-60,a);
 chanWndModer.setFont(new Font("",Font.PLAIN,12));
 chanWndModer.setScroller(msbar);
 chanWndModer.setBackgroundImage(bgImageModer);

 pwm.add(chanWndModer,BorderLayout.WEST);
 pwm.add(msbar, BorderLayout.EAST);

 actions.moderToClose=moderFr;
 bClose.setActionCommand("CLOSEMODER");
 bClose.addActionListener(actions);

 panel.add(pwm,BorderLayout.NORTH);
 panel.add(bClose,BorderLayout.CENTER);

 moderFr.add(panel);
 moderFr.setVisible(true);
}


public String compileText(String text,String param) {
    int paramTmp = text.indexOf("%");
    String t = text.substring(0,paramTmp) + param + text.substring(paramTmp+1);
    return(t);
    }


public void adjustmentValueChanged(AdjustmentEvent e) {
 if (e.getAdjustable() == sbar) chanWnd.moveStart(e.getValue());
 if (e.getAdjustable() == msbar) chanWndModer.moveStart(e.getValue());
}

public void keyTyped(KeyEvent e) { }
public void keyPressed(KeyEvent e) {
	if ((e.getKeyCode() == KeyEvent.VK_ENTER)
&& (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.getText().trim();
		net.send("*MSG|" + login + "|CHAN|" + input.getText().replace('|',':') + "|" + msgColor + "|");
		input.setText("");
		input.setCaretPosition(0);
		}
}

public void keyReleased(KeyEvent e)
{
	if ((e.getKeyCode() == KeyEvent.VK_ENTER)
&& (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.setText("");

input.setCaretPosition(0);
		}
}


public void closeAllFloatingWindow() {
 WindowChat tmpW = new WindowChat();
 for (int i=0; i < windowsList.size(); i++){
     tmpW = (WindowChat)windowsList.elementAt(i);
     tmpW.window.fr.dispose();
     tmpW = null;
     }
 windowsList.removeAllElements();
}


public boolean alreadyExistNick(String nick) {
 WindowChat tmpW = new WindowChat();
 for (int i=0; i < windowsList.size(); i++){
     tmpW = (WindowChat)windowsList.elementAt(i);
     if (tmpW.nick.equals(nick)) return(true);
     }
 return(false);
}


public MsgFloatingWindow getMsgWindowFromList(String nick) {
 WindowChat tmpW = new WindowChat();
 for (int i=0; i < windowsList.size(); i++){
     tmpW = (WindowChat)windowsList.elementAt(i);
     if (tmpW.nick.equals(nick)) return(tmpW.window);
     }
 return(null);
}



public synchronized void destroy() {
    if (net != null) {
	net.send("*CLOSE");
	net.disconnect();
	net=null;
	actions=null;
/*	if (moderate) {
	    moderFr.dispose();
	    chanWndModer=null;
	    }
*/
	context.showDocument(logouthtml,"_self");
	}
}

public void update(Graphics g) { super.paint(g); }
public void start(Graphics g) { repaint(); }
public void stop(Graphics g) {
    closeAllFloatingWindow();
    repaint();
    }
public void paint(Graphics g) { super.paint(g); }


}
