package pl.net.linux.krzak.kchat.applet;
/*****************************/
/* kChat v1.9		     */
/* krzak@linux.net.pl        */
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.List;

public class kChatProtocol {
    private kChatParse parseCommand = null;
    private kChatApplet applet = null;

    public kChatProtocol(kChatApplet a) {
	parseCommand = new kChatParse();
	applet = a;
    }

    public void parse(String buf) {
    if (buf.startsWith("*MSG"))
 {
	String who = parseCommand.getParam(buf,2);
	String where = parseCommand.getParam(buf,3);
	String text = parseCommand.getParam(buf,4);
	String color = parseCommand.getParam(buf,5);
        String s = "";
	s = "<"+who+"> "+text;
	if (where.equals("CHAN"))
 {
	    applet.chanWnd.appendText(s,color);
        }
	// priv, lub do moderatora
	if (where.equals(applet.login))
 {
	    if (applet.moderate) { // to pisze ludek do moderatora
		applet.chanWndModer.appendText(s,color);
	    } else {
    		if  ((applet.alreadyExistNick(who) == false)) {
			MsgFloatingWindow fw = new MsgFloatingWindow(applet.compileText(applet.TXT[12],who),who,applet);
			fw.setVisible(true);
			fw.text.append("*<"+ who +">* " + text + "\n");
			} else {
			MsgFloatingWindow fw = applet.getMsgWindowFromList(who);
			fw.text.append("*<"+ who +">* " + text + "\n");
			}
	    }
	}
    }

    if (buf.startsWith("*LIST"))
 {
	if (applet.nList == null) applet.nList = new List();

	int start = 5;	int end = 5;
	while (buf.indexOf("|",start+1) != -1) {
	    start = end+1;
	    end   = buf.indexOf("|",start+1);
	    if ((start<end) && (!buf.substring(start,end).equals(applet.login))) applet.nList.add(buf.substring(start,end));
	    }
    }

    if (buf.startsWith("*JOIN"))
 {
	String n = parseCommand.getParam(buf,2);
	applet.nList.add(n);
	applet.chanWnd.appendText(applet.compileText(applet.TXT[2],n),"gray"); // "przyszedl"
    }

    if (buf.startsWith("*QUIT"))
 {
	String n = parseCommand.getParam(buf,2);
	for (int i=0;i<applet.nList.getItemCount();i++) {
		if ((applet.nList != null) && (applet.nList.getItem(i).equals(n)))
		    applet.nList.remove(i);
	    }
	applet.chanWnd.appendText(applet.compileText(applet.TXT[5],n),"black"); // "wyszedl"
    }

    if (buf.startsWith("*MODERATED")) {
	if (buf.substring(11,13).equals("NO")) {
	    applet.moderate=false;
	    applet.moderatorNick = "";
	    applet.chanWnd.appendText(applet.TXT[4] ,"gray"); // "kanal nie jest moderowany"
	    } else {
	    applet.moderate=true;
	    applet.moderatorNick = parseCommand.getParam(buf,3);
	    if (!applet.moderatorNick.equals(applet.login)) {
//		applet.moderate=false;
		if ((applet.moderFr != null) && (applet.chanWndModer!=null)) {
		    applet.moderFr.dispose();
		    applet.chanWndModer=null;
		    }
		}
	    applet.chanWnd.appendText(applet.compileText(applet.TXT[3],applet.moderatorNick),"gray"); // "kanal moderowany przez "
	    }
    }

    if (buf.startsWith("*YOUAREMODERATOR")) {
	    applet.moderate=true;
	    applet.chanWnd.appendText(applet.compileText(applet.TXT[14],applet.chan),"red"); // "jestes moderatorem"
	    applet.moderWinOpen(applet);
	    applet.chanWndModer.moderatorMode=true;
	    applet.bPrivate.setLabel(applet.TXT[16]);
	    applet.bPrivate.setActionCommand("KICK");
	    applet.bModerator.setLabel(applet.TXT[17]);
	    applet.bModerator.setActionCommand("TOPIC");
    }
    if (buf.startsWith("*LOGIN"))
{ 
	    String s = parseCommand.getParam(buf,2);
	    if (s.equals("OK")) {
		// get login from serwer !!!
		applet.login=parseCommand.getParam
(buf,3);
		try {
		applet.logouthtml = new java.net.URL(parseCommand.getParam(buf,4));
		} catch (java.net.MalformedURLException e) {
//		    e.printStackTrace();
		    }
		applet.chanWnd.appendText(applet.TXT[0],"black");
		applet.net.send("*MODERATED");
		}
	    if (s.equals("NICK BUSY")) {
		applet.chanWnd.appendText(applet.TXT[11],"black"); // "login zajety"
		}

	}
    if (buf.startsWith("*KICK"))
 {
	applet.chanWnd.appendText(applet.TXT[15],"black");
	applet.net.send("*CLOSE\r\n");
	applet.net.disconnect();
	applet.net=null;
	applet.actions=null;
	applet.context.showDocument(applet.logouthtml,"_self");
	applet = null;
    }

    if (buf.startsWith("*PING"))
 {
	applet.net.send("*PONG\r\n");
    }

    if (buf.startsWith("*LANG"))
 {
	for (int i=0;i<applet.TXT.length;i++) {
	    applet.TXT[i] = parseCommand.getParam(buf,i+2);
	    }
	applet.bPrivate.setLabel(applet.TXT[6]);
	applet.bModerator.setLabel(applet.TXT[7]);
	applet.bLogout.setLabel(applet.TXT[8]);
	applet.bClose.setLabel(applet.TXT[9]);
    }

    if (buf.startsWith("*TOPIC|GET|")) {
	applet.topicLabel.setText("["+applet.chan + "] <-> " + parseCommand.getParam(buf,3));
    }



  }


}