package pl.net.linux.krzak.kchat.sac;
/*****************************/
/* kChat v2.0pre1	     */
/* kChatSac v0.9	     */
/* krzak@linux.net.pl        */
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.Component;
import java.awt.Frame;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Color;
import java.lang.String;
import java.util.Vector;

public class MsgFloatingWindow extends Frame implements WindowListener, ActionListener {
    public String nick = "";
    public String title = "";
    public Frame  fr = null;
    public TextArea text = null;
    private TextField input = null;
    private SacMainWindow main = null;

    MsgFloatingWindow(String title, String nick,SacMainWindow m) {     // konstructor
	super("MsgFloatingWindow");
	this.main = m;
	this.title = title;
	this.nick  = nick;
	this.fr = new Frame(title);
	this.fr.setSize(400,250);
	this.fr.addWindowListener(this);

	this.text = new TextArea("",10,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
	this.text.setEditable(false);
        this.text.setBackground(new Color(117,203,252));

	this.input = new TextField("",10);
	this.input.setFont(new Font("fixed", 0, 12));
	this.input.addActionListener(this);
//	this.input.addFocusListener(this);
//	this.input.requestFocus();

	Panel panel = new Panel(new BorderLayout());
	panel.add(this.text,BorderLayout.CENTER);
	panel.add(this.input,BorderLayout.SOUTH);

	this.fr.add(panel);

	// dodaje do listy nikow
	WindowChat tmp = new WindowChat();
	tmp.nick = nick;
	tmp.window = this;
	main.windowsList.addElement(tmp);
    }



    public void setVisible(boolean state) {
    if (this.fr != null) this.fr.setVisible(state);
    }


    // ***********
    // WINDOW
    // ***********
    public void windowClosing(WindowEvent e) {
	WindowChat tmpW = new WindowChat();
	for (int i=0; i < main.windowsList.size(); i++){
	    tmpW = (WindowChat)main.windowsList.elementAt(i);
	    if (tmpW.nick.equals(nick)) main.windowsList.removeElementAt(i);
	    }
	this.fr.dispose();
    }

    public void windowClosed(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }

    public void windowActivated(WindowEvent e) {
	for (int i = 0; i < main.nList.getItemCount();i++)
	    if (main.nList.getItem(i).equals(this.nick)) main.nList.select(i);
	input.requestFocus();
    }

    public void windowDeactivated(WindowEvent e) {
	for (int i = 0; i < main.nList.getItemCount();i++)
	    if (main.nList.getItem(i).equals(this.nick)) main.nList.deselect(i);
    }


    // ***********
    // INPUT
    // ***********
      public void actionPerformed(ActionEvent e) {
	main.net.send("*MSG|"+ main.login + "|"+ this.nick + "|" + e.getActionCommand()+"|black|");
	String s = "<" + main.login + "> " + e.getActionCommand()+"\n";
	this.text.append(s);
	this.input.setText("");
	this.text.setCaretPosition((this.text.getText()).length());
      }

}
